/*********************************************
 * 
 * Project : Jukebox
 * Author  : Karsten Mueller
 * email   : email@kmkcl.de
 * website : http://kmkcl.de/jukebox.html
 * 
 * Date    : 28.05.2014
 * 
 *********************************************/
#define F_CPU 1120000UL
#include  <avr/io.h>
#include <util/delay.h>
#include <stdio.h>
#include "jukebox.h"
 
int main(void)
{
  //Ein-/Ausgaenge konfigurieren
  DDRB=(1<<SPEAKER);
  PORTB=(1<<PB1);
  
  // Timer/Counter 0 konfigurieren
  // CTC mode, toggle OC0A bei compare match
  // Takt: intern, prescale 8 
  TCCR0A=(1<<WGM01) | (1<<COM0A0);
  uint8_t pos=0;
  uint8_t runde=5;
 
 /* while(!(PINB&(1<<PB1))) 
    	pos++;
  pos%=9;*/
  while(1) 
  {
      runde--;
      uint16_t index=titel[pos];
      uint8_t default_octave=melody[index++];
      uint8_t bpm=melody[index++];
    
      while(melody[index]!=0&&runde)
      { 
	//Note laden
	uint8_t note=melody[index++];
	uint16_t duration=((60000/bpm)>>(note>>5));
	if(note&0x10) duration=(duration*3)/2;
	uint8_t octave=default_octave;
	if((note&0x0F)==0x0E) 
	{
	  note=melody[index++];
	  octave=note>>4;
	}
	if((note&0x0F)!=0x0F) 
	{
	  TON  = frequencies[octave*12+(note&0x0F)-1];
	  TON_AN;
	}
	while(--duration) {
	  _delay_ms(4);
		if(!(PINB&(1<<PB1))) runde=0;
	}
	TON_AUS;
	_delay_ms(4);
      }
      if(runde==0)
      {
	pos++;
	pos%=9;
	runde=5;
	_delay_ms(100);
      }
  }
}
